package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.x509.X509Name;
import java.math.BigInteger;

public class IssuerAndSerialNumber extends ASN1Encodable {
   X509Name name;
   DERInteger serialNumber;

   public static IssuerAndSerialNumber getInstance(Object obj) {
      if (obj instanceof IssuerAndSerialNumber) {
         return (IssuerAndSerialNumber)obj;
      } else if (obj instanceof ASN1Sequence) {
         return new IssuerAndSerialNumber((ASN1Sequence)obj);
      } else {
         throw new IllegalArgumentException("Illegal object in IssuerAndSerialNumber: " + obj.getClass().getName());
      }
   }

   public IssuerAndSerialNumber(ASN1Sequence seq) {
      this.name = X509Name.getInstance(seq.getObjectAt(0));
      this.serialNumber = (DERInteger)seq.getObjectAt(1);
   }

   public IssuerAndSerialNumber(X509Name name, BigInteger serialNumber) {
      IssuerAndSerialNumber var10000 = this;
      super();
      this.name = name;
      DERInteger var3;
      var3 = new DERInteger.<init>(serialNumber);
      var10000.serialNumber = var3;
   }

   public IssuerAndSerialNumber(X509Name name, DERInteger serialNumber) {
      this.name = name;
      this.serialNumber = serialNumber;
   }

   public X509Name getName() {
      return this.name;
   }

   public DERInteger getSerialNumber() {
      return this.serialNumber;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.name);
      var10000.add(this.serialNumber);
      return new DERSequence(var1);
   }
}
